﻿package {
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.TextField;	//	NB: This line needs to be added for the challenge!
	import flash.text.TextFormat;	//	NB: This line needs to be added for the challenge!
	import flash.utils.setTimeout;	//	NB: This line needs to be added for the challenge!
	
	public class ChessboardSolution extends MovieClip {
		//	(1) make a MovieClip called board. use stage.addChild() to add the board to the visual area (the stage canvas)
		var board:MovieClip;	
		
		//	challenge: Textfield to show coordinates on the stage
		var tf:TextField;	
		
		public function ChessboardSolution() {
			board					= new MovieClip();
			
			//	challenge: setting some Textfield properties
			tf						= new TextField();
			tf.x					= 100;
			tf.y					= 30;
			tf.width				= 600;
			tf.height				= 50;
			tf.selectable			= false;
			tf.defaultTextFormat	= new TextFormat( "Arial", 20 );
			tf.text					= "Square clicked: ";
			stage.addChild( board );
			stage.addChild( tf );					
			
			//	(2) make a loop, and inside it a nested loop (so a for loop within another for loop). Each loop loops 8 times (a chessboard is 8x8)
			for( var i:int = 0; i < 8; i ++ ) {
				for( var j:int = 0; j < 8; j ++ ) {
					//	(3) inside the inner loop, create a new MovieClip called square
					var square:MovieClip = new MovieClip();	
					
					//	(4) check whether the current square should be a white or a black one (hint: use modulo here)
					//	(5) use square.graphics.beginFill( 0xFFFFFF ); to draw with white or ..( 0x000000 ) for black
					//	use square.graphics.drawRect( 0, 0, 50, 50 ); to draw a 50x50 pixel square. For specific use, see the Help file.
					if( ( i + j ) % 2 == 0 ) {					
						square.graphics.beginFill( 0xFFFFFF );	
						//	challenge: add extra property
						square.isWhite = true;
					} else {
						square.graphics.beginFill( 0x000000 );			
						square.isWhite = false;
					}
					square.graphics.drawRect( 0, 0, 50, 50 );			
					square.graphics.endFill();
					
					//	(6) now use the .x and .y properties of your square MovieClip to set its location dynamically (i.e., using the loops' counters)
					square.x = 100 + i * 50;							
					square.y = 100 + j * 50;
					
					//	(7) set the square's .name property to identify it later
					square.name = "(" + String( i + 1 ) + "," + String( j + 1 ) + ")";
					
					//	(8) use board.addChild() to add the square to the board
					board.addChild( square );
					
					//	(9) use the addEventListener() function to add a listening device to the square.
					square.addEventListener( MouseEvent.CLICK, onMouseClick );					
				}
			}
		}
		
		//	(10) make a separate listener function that traces the event's target's name.
		private function onMouseClick( evt:MouseEvent ) :void {
			trace( evt.target.name );
			
			//	challenge: change the text and color
			if( evt.target.isWhite ) {					
				evt.target.graphics.beginFill( Math.random() * 0xFFFFFF );		
				evt.target.graphics.drawRect( 0, 0, 50, 50 );			
				evt.target.graphics.endFill();
				
				tf.text = "Square clicked: " + evt.target.name + " was white.";
			} else {
				tf.text = "Square clicked: " + evt.target.name + " is black.";
			}
			//	challenge: set a timer to reset the text and color
			setTimeout( removeText, 1000, evt.target );
		}
		
		
		//	challenge: separate function to reset the text and color
		private function removeText( target:MovieClip ) :void {
			tf.text = "Square clicked: ";
			if( target.isWhite ) {		
				target.graphics.beginFill( 0xFFFFFF );		
				target.graphics.drawRect( 0, 0, 50, 50 );			
				target.graphics.endFill();
			}
		}
	}
}